﻿Imports System.Runtime.InteropServices
Imports System.Threading

Module Module_Utils

    Friend Running As Boolean

    ' =======================================================================================================
    '   APP TITLE AND VERSION (ALL FIELDS)
    ' =======================================================================================================
    Friend Function AppTitleAndVersion(Optional ByVal RemoveThereminoPrefix As Boolean = False) As String
        Dim appname As String = IO.Path.GetFileNameWithoutExtension(Application.ExecutablePath)
        Dim Title As String = Replace(appname, "_", " ")
        If RemoveThereminoPrefix Then Title = Replace(Title, "Theremino ", "")
        Return Title + " - V" + GetVersionString()
    End Function

    ' =======================================================================================================
    '   GET VERSION (ALSO TRIPLE OR QUADRUPLE FIELDS)
    ' =======================================================================================================
    Friend Function GetVersionString() As String
        Dim s() As String = Split(My.Application.Info.Version.ToString, ".")
        GetVersionString = s(0) + "." + s(1)
        If s(2) <> "0" Then
            GetVersionString += "." + s(2)
            If s(3) <> "0" Then
                GetVersionString += "." + s(3)
            End If
        End If
    End Function

    ' ===============================================================================================
    '  SCROLL TO BOTTOM
    ' ===============================================================================================
    Private Declare Auto Function SendMessage_Scroll _
                Lib "user32.dll" Alias "SendMessage" _
                (ByVal hWnd As IntPtr, _
                 ByVal Msg As Integer, _
                 ByVal wParam As Int32, _
                 ByRef lParam As Int32) As Integer

    Private Const WM_VSCROLL As Integer = &H115

    Private Const SB_BOTTOM As Integer = 7

    ' -------------------------------------------------------  
    Friend Sub ScrollToBottom(ByVal handle As IntPtr)
        SendMessage_Scroll(handle, _
                           WM_VSCROLL, _
                           SB_BOTTOM, _
                           0)
    End Sub


    ' ===================================================================================================
    '  FONT
    ' ===================================================================================================
    Friend Sub SetRichTextBoxFont(ByVal rtb As RichTextBox, ByVal FontName As String)
        With rtb
            ' ----------------------------------------------- ensure a complete font initialization
            .Font = New Font("Arial", 8)
            ' This option allows to use Chinese and Japanese chars mixed with Latin chars
            ' otherwise the font is changed to "Segoe UI Symbol" after displaying oriental chars 
            .LanguageOption = RichTextBoxLanguageOptions.DualFont
            ' The font-size determines the number of spaces for each TAB
            ' with font-size 15 each TAB is similar to 4 spaces
            .Font = New Font(FontName, 15, FontStyle.Regular)
            ' ------------------------------------------------------------------------------------
            '.AcceptsTab = True
            '.DetectUrls = False
            '.WordWrap = False
            .HideSelection = False
        End With
    End Sub

End Module
